searchNodes=[{"doc":"Expose more user friendly API for underlying modules.","ref":"CozyParams.html","title":"CozyParams","type":"module"},{"doc":"Defines a function for casting and validating params. Essentially, this macro is just a shortcut for using CozyParams.Schema . Inspired by vic/params . Examples defmodule Demo do import CozyParams defparams :product_search do field :name , :string , required : true end def search ( params ) do with { :ok , data } &lt;- product_search ( params ) do # process data end end end Above defparams :product_search do: block will: create a module Demo.CozyParams.ProductSearch automatically. inject product_search/1 into current module. And, this function will call Demo.CozyParams.ProductSearch.from/1 internally. For more details of the schema definitions in do: block , check out CozyParams.Schema . Error handling When external params are invalid, {:error, params_changeset: %Ecto.Changeset{}} will be returned, which allows developers to match this pattern for handling errors. If the error messages is required, CozyParams.get_error_messages/1 would be helpful.","ref":"CozyParams.html#defparams/2","title":"CozyParams.defparams/2","type":"macro"},{"doc":"Extract error messages from %Ecto.Changeset{} .","ref":"CozyParams.html#get_error_messages/1","title":"CozyParams.get_error_messages/1","type":"function"},{"doc":"Extract error messages from %Ecto.Changeset{} with a given function. The msg_func will be passed to Ecto.Changeset.traverse_errors/2 , read doc of Ecto.Changeset.traverse_errors/2 for more information.","ref":"CozyParams.html#get_error_messages/2","title":"CozyParams.get_error_messages/2","type":"function"},{"doc":"Provides macros for defining schemas which is used for casting and validating params. Due to limitations of implementation, it's impossible to document every supported macros within @doc . Because of that, I will try to best to document them within @moduledoc . Available macros CozyParams.Schema provides a subset of macros supported by Ecto, In addition, it makes some changes on embeds_one and embeds_many . In a nutshell, all available macros are: schema(do: block) field(name, type, opts \\\\ []) available opts : :default :required - default: false :pre_cast - specify a unary function to process data before casting embeds_one(name, opts \\\\ [], do: block) available opts : :required - default: false embeds_one(name, schema, opts \\\\ []) available opts : :required - default: false embeds_many(name, opts \\\\ [], do: block) available opts : :required - default: false embeds_many(name, schema, opts \\\\ []) available opts : :required - default: false type argument will be passed to Ecto.Schema , so it supports all the types supported by Ecto.Schema in theory. Read Types and casting section of Ecto.Schema to get more information. Examples There're 2 ways to define a schema: use inline syntax use extra modules Define a schema contains embedded fields in inline syntax: defmodule PersonParams do use CozyParams.Schema schema do field :name , :string , required : true field :age , :integer field :wishlist , { :array , :string } , pre_cast : &amp; String . split ( &amp;1 , ~r/, \\s */ ) embeds_one :mate , required : true do field :name , :string , required : true field :age , :integer end embeds_many :pets do field :name , :string , required : true field :breed , :string end end end PersonParams . from ( %{ name : &quot;Charlie&quot; , mate : %{ name : &quot;Lucy&quot; } , wishlist : &quot;table,chair,computer&quot; } ) Define a schema contains embedded fields with extra modules: defmodule PersonParams do use CozyParams.Schema defmodule Mate do use CozyParams.Schema schema do field :name , :string , required : true field :age , :integer field :wishlist , { :array , :string } , pre_cast : &amp; String . split ( &amp;1 , ~r/, \\s */ ) end end defmodule Pet do use CozyParams.Schema schema do field :name , :string , required : true field :breed , :string end end schema do field :name , :string , required : true field :age , :integer embeds_one :mate , Mate , required : true embeds_many :pets , Pet end end PersonParams . from ( %{ name : &quot;Charlie&quot; , mate : %{ name : &quot;Lucy&quot; } , wishlist : &quot;table,chair,computer&quot; } ) About the generated functions schema/1 will create 2 functions automatically: changeset/2 which is overridable. from/1 which will be called by high-level abstractions, such as CozyParams . Reflection Schemas will generate the following functions that can be used for runtime introspection of the schema: __cozy_params_schema__/0 __cozy_params_schema__/1 __cozy_params_changeset__/0 __cozy_params_changeset__/1 All possible calls: __cozy_params_schema__() - an alias of __cozy_params_schema__(:metadata) . __cozy_params_schema__(:metadata) - returns the metadata of current schema. __cozy_params_schema__(:original_ast) - returns the original AST passed to schema/1 . __cozy_params_schema__(:transpiled_ast) - returns the transpiled AST used by cozy_params . __cozy_params_schema__(:ecto_ast) - returns the AST used by Ecto. __cozy_params_changeset__() - an alias of __cozy_params_changeset__(:metadata) . __cozy_params_changeset__(:metadata) - returns the metadata used by CozyParams.Changeset .","ref":"CozyParams.Schema.html","title":"CozyParams.Schema","type":"module"},{"doc":"","ref":"CozyParams.Schema.html#schema/1","title":"CozyParams.Schema.schema/1","type":"macro"},{"doc":"Process the AST of cozy_params .","ref":"CozyParams.Schema.AST.html","title":"CozyParams.Schema.AST","type":"module"},{"doc":"Make sure that the AST is always a block.","ref":"CozyParams.Schema.AST.html#as_block/1","title":"CozyParams.Schema.AST.as_block/1","type":"function"},{"doc":"Transform cozy_params supported AST to Ecto supported AST. Currently, this function will: drop options which are supported by cozy_params only. Or, Ecto will report invalid option errors.","ref":"CozyParams.Schema.AST.html#as_ecto_block/1","title":"CozyParams.Schema.AST.as_ecto_block/1","type":"function"},{"doc":"Extract metadata from AST.","ref":"CozyParams.Schema.AST.html#extract_metadata/1","title":"CozyParams.Schema.AST.extract_metadata/1","type":"function"},{"doc":"Transpile shortcuts of embeds_one and embeds_many . cozy_params will transpile code like following one: embeds_one :address , required : true do field :latitude , :float , required : true field :longtitude , :float , required : true end to Ecto supported code: defmodule Address do use CozyParams.Schema schema do field :latitude , :float , required : true field :longtitude , :float , required : true end end embeds_one :address , Address","ref":"CozyParams.Schema.AST.html#transpile_block/2","title":"CozyParams.Schema.AST.transpile_block/2","type":"function"},{"doc":"Validate if the block meets cozy_params 's requirements. Although cozy_params try its best to emulate the API of Ecto.Schema , but it doesn't mean that every API of Ecto.Schema is supported by cozy_params . Because of that, cozy_params validates the calls before proceeding.","ref":"CozyParams.Schema.AST.html#validate_block!/1","title":"CozyParams.Schema.AST.validate_block!/1","type":"function"},{"doc":"Provides Ecto-like API for casting and validating params.","ref":"readme.html","title":"CozyParams","type":"extras"},{"doc":"There are some packages in the community: NAME Based on Ecto? Use Ecto-like API? params YES NO maru_params NO NO tarams NO NO ... But, they don't fit my requirements. The package in my dream should: be based on Ecto which is robust and battle-tested. use Ecto-like API, which eliminates friction when working on casting params and modeling data source at the same time.","ref":"readme.html#why-another-package","title":"CozyParams - Why another package?","type":"extras"},{"doc":"Add cozy_params to your list of dependencies in mix.exs : def deps do [ { :cozy_params , &quot;~&gt; 1.0.0&quot; } ] end (Optional) And, it's encouraged to setup .formatter.exs for cozy_params : [ import_deps : [ # ... :cozy_params ] , # ... ]","ref":"readme.html#installation","title":"CozyParams - Installation","type":"extras"},{"doc":"CozyParams - provides macros for general usage. CozyParams.Schema - provides macros for defining schemas directly. An example integrating with Phoenix: defmodule DemoWeb.PageController do use DemoWeb , :controller import CozyParams action_fallback DemoWeb.FallbackController defparams :product_search do field :name , :string , required : true embeds_many :tags do field :name , :string , required : true end end def index ( conn , params ) do with { :ok , data } &lt;- product_search ( params ) do # ... end end end defmodule DemoWeb.FallbackController do use DemoWeb , :controller # ... # handle errors for cozy_params def call ( conn , { :error , params_changeset : % Ecto.Changeset { } = changeset } ) do messages = CozyParams . get_error_messages ( changeset ) # render messages in HTML, JSON, etc. end # handle errors for normal changsets from Ecto. def call ( conn , { :error , % Ecto.Changeset { } = changeset } ) do # ... end # ... end Visit HexDocs for more details.","ref":"readme.html#overview","title":"CozyParams - Overview","type":"extras"},{"doc":"Apache License 2.0","ref":"readme.html#license","title":"CozyParams - License","type":"extras"},{"doc":"","ref":"faq.html","title":"FAQ","type":"extras"},{"doc":"casting and validating params defmodule DemoWeb.PageController do use DemoWeb , :controller import CozyParams defparams :product_search do field :name , :string , required : true end def index ( conn , params ) do with { :ok , data } &lt;- product_search ( params ) do # when external params are invalid, `{:error, params_changeset: %Ecto.Changeset{}}` # will be returned. end end end error handling As mentioned above, when external params are invalid, {:error, params_changeset: %Ecto.Changeset{}} will be returned, which allows developers to match this pattern in the fallback controller, and convert the changeset as error messages by using CozyParams.get_error_messages/1 . For example: defmodule DemoWeb.PageController do use DemoWeb , :controller import CozyParams action_fallback DemoWeb.FallbackController defparams :product_search do field :name , :string , required : true end def index ( conn , params ) do with { :ok , data } &lt;- product_search ( params ) do # ... end end end defmodule DemoWeb.FallbackController do use DemoWeb , :controller # ... # handle errors for cozy_params def call ( conn , { :error , params_changeset : % Ecto.Changeset { } = changeset } ) do messages = CozyParams . get_error_messages ( changeset ) # render messages in HTML, JSON, etc. end # handle errors for normal changsets from Ecto. def call ( conn , { :error , % Ecto.Changeset { } = changeset } ) do # ... end # ... end","ref":"faq.html#how-to-integrate-with-phoenix","title":"FAQ - How to integrate with Phoenix?","type":"extras"},{"doc":"By default, cozy_params just: casts types of fields. validates presence of fields. But, people usually expect more, such as validating format, etc. The easiest way is to override changeset/2 in a schema. For example: defmodule SampleParams do use CozyParams.Schema schema do field :name , :string , required : true field :age , :integer embeds_one :mate , required : true do field :name , :string , required : true field :age , :integer end embeds_many :pets do field :name , :string , required : true field :breed , :string end end def changeset ( struct , params ) do struct |&gt; super ( params ) |&gt; Ecto.Changeset . validate_ * # ... end end A harder way is to extend CozyParams.Schema at AST level, which requires you to improve CozyParams.Schema.AST .","ref":"faq.html#how-to-expand-the-capabilities-of-schemas","title":"FAQ - How to expand the capabilities of schemas?","type":"extras"}]